#include "ej4-5.h"

using namespace std;

Cuenta::Cuenta(double saldo) : saldo_(saldo) {}

double Cuenta::getSaldo() const    { return saldo_; }
void Cuenta::ingresar(double cant) { saldo_ += cant; }
void Cuenta::retirar(double cant)  { saldo_ -= cant; }

Persona::Persona(int dni) : dni_(dni){
  moroso_ = false;
  numCuentas_ = 0;
}

void Persona::anadirCuenta(Cuenta c1) {
  if (numCuentas_ < 3) {
    cuentas_[numCuentas_] = c1; 
  }
  numCuentas_++;
}

void Persona::quitarCuenta(int pos) {
  if (pos >= 0 && pos < numCuentas_) {
    for (int i=pos; i<numCuentas_-1; i++) {
      cuentas_[i] = cuentas_[i+1]; 
    }
    numCuentas_--;
  }
}

void Persona::ingresar(double cantidad, int poscuenta) {
  if (poscuenta >=0 && poscuenta < numCuentas_) {
    cuentas_[poscuenta].ingresar(cantidad);
    comprobarMoroso();
  }
}

void Persona::retirar(double cantidad, int poscuenta) {
  if (poscuenta >= 0 && poscuenta < numCuentas_) {
    cuentas_[poscuenta].retirar(cantidad);
    comprobarMoroso();
  }
}

void Persona::comprobarMoroso() {
  moroso_ = false;
  for (int i=0; i<3; i++) {
    if (cuentas_[i].getSaldo() < 0.0) {
      moroso_ = true;
      break;
    }
  }
}

bool Persona::esMoroso() { return moroso_;}

void Persona::imprimirSaldos() {
  for (int i=0; i<numCuentas_; i++) {
    cout << "cuenta " << i << " saldo: " << cuentas_[i].getSaldo() << endl;
  }
}

int main() {
  Persona p1(123456);
  Cuenta c1, c2(700);
  p1.anadirCuenta(c1);
  p1.anadirCuenta(c2);
  p1.imprimirSaldos();
  cout << "antes de ingreso la persona es morosa " << p1.esMoroso() << endl;
  p1.ingresar(1100,0);
  p1.imprimirSaldos();


  p1.retirar(750,1);
  p1.imprimirSaldos();
  cout << "despues de ingreso la persona es morosa " << p1.esMoroso() << endl;
  p1.retirar(50,0);
  p1.ingresar(50,1);
  p1.imprimirSaldos();
  cout << "despues de transferencia la persona es morosa " << p1.esMoroso() << endl;
}

